!**** Handler places everything in a DOM and after parsing
!**** traverses the DOM and prints out the document again

      subroutine xmlhandler3(in,name,value,out)

      use xml_parser
      use xml_node

      implicit none
      integer, intent(in)        :: in
      character(*), intent(in)   :: name,value
      integer, intent(out)       :: out

      type(node), pointer, save  :: root
      type(node), pointer, save  :: c

      logical, parameter         :: v = .false.
      character(*), parameter    :: f = '(a)'
      integer, parameter         :: io = 22
      integer, parameter         :: ix = 77
      character(*), parameter    :: d = '"'


      out = 0

      select case(in)
      case(HANDLER_START_ELEMENT)
          call append_child(c,ELEMENT_NODE,name,'')
          c => last_child_node(c)
          if (v) write(io,f) 'START ELEMTENT: ' // name
      case(HANDLER_END_ELEMENT)
          c => get_parent(c)
          if (v) write(io,f) 'END ELEMENT: ' // name
      case(HANDLER_EMPTY_ELEMENT)
          c => get_parent(c)
          if (v) write(io,f) 'EMPTY ELEMENT'
      case(HANDLER_START_ATTRIBUTES)
          continue
      case(HANDLER_END_ATTRIBUTES)
          continue
      case(HANDLER_START_XML_DECLARATION)
          continue
      case(HANDLER_END_XML_DECLARATION)
          continue
      case(HANDLER_DTD)
          call append_child(c,DTD_NODE,'',value)
          if (v) write(io,f) 'DTD'
      case(HANDLER_ATTRIBUTE)
          call add_attribute(c,name,value)
          if (v) write(io,f) 'ATTRIBUTE: ' // name // '=' // d // value // d
      case(HANDLER_PI)
          call append_child(c,PI_NODE,'',value)
          if (v) write(io,f) 'PI'
      case(HANDLER_COMMENT)
          call append_child(c,COMMENT_NODE,'',value)
          if (v) write(io,f) 'COMMENT'
      case(HANDLER_CDATA)
          call append_child(c,CDATA_SECTION_NODE,'',value)
          if (v) write(io,f) 'CDATA SECTION'
      case(HANDLER_CHARDATA)
          call append_child(c,TEXT_NODE,'',value)
          if (v) write(io,f) 'TEXT'
      case(HANDLER_REFERENCE)
          call append_child(c,ENTITY_REFERENCE_NODE,'',value)
          continue
      case(HANDLER_START_DOCUMENT)
          call append_child(root,DOCUMENT_NODE,'','')
          c => root
      case(HANDLER_END_DOCUMENT)
          continue
          c => root
          open(ix,file='AAA',recl=1000000)
          call print_node(ix,c)
          close(ix)
          write(6,*) "XML file rewritten in file 'AAA'"
      case(HANDLER_START_CONTENT)
          continue
      case(HANDLER_END_CONTENT)
          continue
      case(HANDLER_START_PROLOG)
          continue
      case(HANDLER_END_PROLOG)
          continue
      case(HANDLER_START_ROOT_ELEMENT)
          continue
      case(HANDLER_END_ROOT_ELEMENT)
          continue
      case default
          stop 'HANDLER3: unknown handler code'
      end select

      end subroutine xmlhandler3
