      program xmltest

      use characters
      use xml_parser
      use input

      implicit none
      character                :: cbuffer(bsize)
      integer                  :: length,status,io,i,ii,ic
      integer                  :: c,line(2)
      character(108)           :: file
      integer, external        :: u_iargc
      real                     :: t1,t2
      character(*), parameter  :: f = '(a,f4.2)'

      external xmlhandler0
      external xmlhandler1
      external xmlhandler2
      external xmlhandler3



      if (u_iargc() /= 1) stop 'XMLTEST: exactly one argument expected'
      call u_getarg(1,file)

      call cpu_time(t1)
      call initialize_characters()
      call cpu_time(t2)
      write(6,f) 'Initializing character stuff: ',t2-t1
      t1 = t2

      call open_tstream(trim(file),io)
      call fill_buffer(io,buffer,length)
      close(io)

      call count_lines(buffer,length,lines)

      call cpu_time(t2)

      if (length <= 0) stop 'XMLTEST: fill_buffer length <= 0'
      write(6,f) 'Filling buffer: ',t2-t1

!     call parse_document(buffer(1:length),xmlhandler0,c,status)
!     call parse_document(buffer(1:length),xmlhandler1,c,status)
!     call parse_document(buffer(1:length),xmlhandler2,c,status)
      call parse_document(buffer(1:length),xmlhandler3,c,status)
      call cpu_time(t1)
      write(6,f) 'Parsing:        ',t1-t2

      if (status /= 0)  then
          line = xline(lines,c)
          write(6,*) 'Status = ', status,  &
                     ' on line ', line(1),  &
                     ' position ', line(2)
      endif

      end program xmltest
